/**
 * demo.js
 * https://coidea.website
 *
 * Licensed under the MIT license.
 * http://www.opensource.org/licenses/mit-license.php
 * 
 * Copyright 2018, COIDEA
 * https://coidea.website
 */

$(function() {

  // header:headline =============
  anime.timeline({ loop: false })
  // in animation
  .add({ targets: '.section-header .content', opacity: [0,1], easing: "easeOutCirc", duration: 800, delay: function(el, i) { return 800 * i; } })

  // example #1 ==================
  $('.example-1').each(function(){
    $(this).html($(this).text().replace(/([^\x00-\x80]|\w)/g, "<span class='letter'>$&</span>"));
  });

  // timeline
  const animation = anime.timeline({ direction: 'alternate', loop: false, autoplay: false });
  // animation
  animation
  // in animation
  .add({
    targets: '.example-1 .letter',
    translateX: [0,-18],
    opacity: [1,0],
    easing: "easeInExpo",
    duration: 750,
    delay: function(el, i) {
      return 100 + 30 * i;
    }
  })
  // out animation
  .add({
    targets: '.example-1 .letter',
    color: '#009688',
    translateX: [18,0],
    translateZ: 0,
    opacity: [0,1],
    easing: "easeOutExpo",
    duration: 750,
    delay: function(el, i) {
      return 500 + 30 * i;
    }
  });

  // trigger 1st animation
  $(".example-1").hover(
    function(e){
      if (animation.reversed) {
        animation.reverse()
      }
      animation.play();
    }, // over
    function(e){
      if (!animation.reversed) {
        animation.play()
      }
      animation.reverse();
    }  // out
  );


  // example #2 ==================

  $('.example-2').each(function(){
    $(this).html($(this).text().replace(/([^\x00-\x80]|\w)/g, "<span class='letter'>$&</span>"));
  });
  
  const animation2 = anime.timeline({
    direction: 'alternate',
    loop: false,
    autoplay: false
  });
  
  animation2
    .add({
      targets: '.section-2nd .line',
      height: '100%',
      easing: "easeInOutExpo",
      duration: 600
    }).add({
      targets: '.example-2 .letter',
      opacity: [1,0],
      translateY: [0, '-1.1em'],
      translateZ: 0,
      duration: 150,
      delay: function(el, i) {
        return 10 * i;
      }
    }).add({
      targets: '.example-2 .letter',
      color: '#212121',
      opacity: [0,1],
      translateY: ['-1.1em', 0],
      translateZ: 0,
      duration: 600,
      delay: function(el, i) {
        return 50 * i;
      }
    });
  
  $(".link-holder-2").hover(
    function(e){
      if (animation2.reversed) {
        animation2.reverse()
      }
      animation2.play();
    }, // over
    function(e){
      if (!animation2.reversed) {
        animation2.play()
      }
      animation2.reverse();
    }  // out
  );


  // example #3 ==================

  $('.example-3').each(function(){
    $(this).html($(this).text().replace(/([^\x00-\x80]|\w)/g, "<span class='letter'>$&</span>"));
  });
  
  const animation3 = anime.timeline({
    direction: 'alternate',
    loop: false,
    autoplay: false
  });
  
  animation3
    .add({
      targets: '.example-3 .letter',
      scale: [1, 0.3],
      opacity: [1,0],
      translateZ: 0,
      easing: "easeOutExpo",
      duration: 600,
      delay: function(el, i) {
        return 70 * (i+1)
      }
    }).add({
      targets: '.link-holder-3 .line-1',
      bottom: ['10px', '100%'],
      easing: "easeOutExpo",
      duration: 600,
      delay: function(el, i, l) {
        return 80 * (l - i);
      }
    }).add({
      targets: '.example-3 .letter',
      color: '#009688',
      scale: [0.3, 1],
      opacity: [0,1],
      translateZ: 0,
      easing: "easeOutExpo",
      duration: 600,
      delay: function(el, i) {
        return 70 * (i+1)
      }
    });
    
  $(".link-holder-3").hover(
    function(e){
      if (animation3.reversed) {
        animation3.reverse()
      }
      animation3.play();
    }, // over
    function(e){
      if (!animation3.reversed) {
        animation3.play()
      }
      animation3.reverse();
    }  // out
  );


  // example #4 ==================

  $('.example-4').each(function(){
    $(this).html($(this).text().replace(/([^\x00-\x80]|\w)/g, "<span class='letter'>$&</span>"));
  });
  
  const animation4 = anime.timeline({
    direction: 'alternate',
    loop: false,
    autoplay: false
  });
  
  animation4
    .add({
      targets: '.example-4 .letter',
      scale: [1,0],
      opacity: [1,0],
      translateZ: 0,
      easing: "easeOutExpo",
      duration: 950,
      delay: function(el, i) {
        return 70*i;
      }
    }).add({
      targets: '.example-4 .letter',
      color: '#009688',
      scale: [4,1],
      opacity: [0,1],
      translateZ: 0,
      easing: "easeOutExpo",
      duration: 950,
      delay: function(el, i) {
        return 70*i;
      }
    });
    
  $(".example-4").hover(
    function(e){
      if (animation4.reversed) {
        animation4.reverse()
      }
      animation4.play();
    }, // over
    function(e){
      if (!animation4.reversed) {
        animation4.play()
      }
      animation4.reverse();
    }  // out
  );


  // example #5 ==================

  $('.example-5').each(function(){
    $(this).html($(this).text().replace(/([^\x00-\x80]|\w)/g, "<span class='letter'>$&</span>"));
  });
  
  const animation5 = anime.timeline({
    direction: 'alternate',
    loop: false,
    autoplay: false
  });
  
  animation5
    .add({    
      targets: '.example-5 .letter',
      rotateY: [0, 90],
      easing: "easeInExpo",
      duration: 750,
      delay: function(el, i) {
        return 45 * i;
      }
    }).add({    
      targets: '.example-5 .letter',
      color: '#009688',
      rotateY: [-90, 0],
      duration: 1300,
      delay: function(el, i) {
        return 45 * i;
      }
    });
   
  $(".example-5").hover(
    function(e){
      if (animation5.reversed) {
        animation5.reverse()
      }
      animation5.play();
    }, // over
    function(e){
      if (!animation5.reversed) {
        animation5.play()
      }
      animation5.reverse();
    }  // out
  );



  // example #6 ==================

  $('.example-6').each(function(){
    $(this).html($(this).text().replace(/([^\x00-\x80]|\w)/g, "<span class='letter'>$&</span>"));
  });

  const animation6 = anime.timeline({
    direction: 'alternate',
    loop: false,
    autoplay: false
  });

  animation6
    .add({
      targets: '.example-6 .letter',
      opacity: [1,0],
      easing: "easeInOutQuad",
      duration: 600,
      delay: function(el, i) {
        return 50 * (i+1)
      }
    }).add({
      targets: '.example-6 .letter',
      color: '#009688',
      opacity: [0,1],
      easing: "easeInOutQuad",
      duration: 600,
      delay: function(el, i) {
        return 50 * (i+1)
      }
    });
    
  $(".example-6").hover(
    function(e){
      if (animation6.reversed) {
        animation6.reverse()
      }
      animation6.play();
    }, // over
    function(e){
      if (!animation6.reversed) {
        animation6.play()
      }
      animation6.reverse();
    }  // out
  );
  

});